/*
 * @Author       : ChenJie
 * @Date         : 2022-02-10 11:43:56
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2022-05-17 17:49:46
 * @Description  : file content
 * @FilePath     : \S32K146_4G\src\AppTaskUart1.c
 */
/*
 * AppTaskUart2.c
 *  4GĴں
 *  Created on: 2022210
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskUart1.h"
#include "hal_fls.h"

const ATCmdFunc Atcmdfunc[] = {
	{AT_CMD_TEST, "AT\r\n", at_callbackFunc},
	{AT_ATE0, "ATE0\r\n", at_callbackFunc},
	{AT_SIMREADY, "AT+CPIN?\r\n", at_callbackFunc},
	{AT_GETICCID, "AT+CICCID\r\n", at_callbackFunc},
	{AT_CGREG, "AT+CGREG?\r\n", at_callbackFunc},
	{AT_CSQ, "AT+CSQ\r\n", at_callbackFunc},
	{AT_NETOPEN, "AT+NETOPEN\r\n", at_callbackFunc},
	{AT_CGIP, "AT+CDNSGIP=", at_callbackFunc},
	//{AT_CONNECT, "AT+CIPOPEN=0,\"TCP\",\"120.26.68.165\",14319\r\n", at_callbackFunc},
	{AT_CONNECT, "AT+CIPOPEN=", at_callbackFunc},
	{AT_CONNECTCHK, "AT+CIPOPEN?\r\n", at_callbackFunc},
	{AT_SEND, "AT+CIPSEND=", at_callbackFunc},
	{AT_DISCON, "AT+CIPCLOSE=0\r\n", at_callbackFunc},
	{AT_NETCLOSE, "AT+NETCLOSE\r\n", at_callbackFunc},
	{AT_CGNSSPWR,"AT+CGNSSPWR=1\r\n",at_callbackFunc}};

static process_Tcp gProcess_Tcp_Task = PROCESS_TCP_INIT;
#define PROC_TCP_STATE_SWITCH(a) (gProcess_Tcp_Task = a)
void InitFunc(void);
sint8 TcpConnectFunc(sint8 *ConnectId);
sint8 TcpDataSendFunc(sint8 ConnectId);
sint8 TcpRegisterChkFunc(void);
void TcpDataEncode(uint32 *PtrSendAddr, uint16 *SendLen);
void GetUtc8Time(UTC8TimeType *UTC8TimeTcp);
static void AtcmdTransmit(sint8 CmdIdx, uint8 *SetValuePtr, uint16 SetValueLen, sint8 *retFunc,uint16 timeout);
static void TcpDataInfoRecvHandle(uint8 *DataRecv, uint16 DataRecvLen);
static void GetCSQValue(uint8 *out);
void Fota_Ftp(uint8 *dataPtrIn);
void tcpUdsFunc(uint8 *Ptr,uint8 *AnsPtr);
static void vTimer1000msCallback(TimerHandle_t pxTimer);
bool SendTimerFlg = false;
static uint32 TcpSendTimeCounter = 0;
extern boolean waitForSleepFlag;
boolean Uart_4G_Task_Sleep_FLag = false;
void Uart_4G_Task(void *pvParameters)
{
	(void)pvParameters;
	uint32 RecvTimerDelay = 0;
	uint8 UartRecvPtr[512];
	volatile uint16 tcpErrorCounter = 0;
	uint16 pReadLen = 0;
	// 4G
	Dio_LevelType _4G_Status = 0; // 0-ػ1-
//	Dio_WriteChannel(DioConf_DioChannel_PTA6_GPIO_OUT_MCU_4G_POW_EN, STD_ON);
//	vTaskDelay(pdMS_TO_TICKS(500));
//	Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_ON);
//	vTaskDelay(pdMS_TO_TICKS(50));
//	AtcmdDelayRecvFunc(UART_LPUART1,(char *)("SMS DONE"),30000);
//	Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_OFF);
//	_4G_Status = Dio_ReadChannel(DioConf_DioChannel_PTB1_GPIO_IN_MCU_4G_STATUS);
//	InitFunc(); // 4Gģʼ,עATͬͨûнджת
	TimerHandle_t monitorTimer1000ms;
	monitorTimer1000ms = xTimerCreate("monitor1000ms",1000,pdTRUE,(void *)0,vTimer1000msCallback);
	xTimerStart(monitorTimer1000ms,0);
	for (;;)
	{

		if(waitForSleepFlag == true)
		{
			PROC_TCP_STATE_SWITCH(PROCESS_TCP_SLEEP);
		}
		switch (gProcess_Tcp_Task)
		{
			case PROCESS_TCP_INIT:
			{
				Dio_WriteChannel(DioConf_DioChannel_PTA6_GPIO_OUT_MCU_4G_POW_EN, STD_ON);
				vTaskDelay(pdMS_TO_TICKS(500));

				Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_ON);
				vTaskDelay(pdMS_TO_TICKS(50));
				Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_OFF);

				AtcmdDelayRecvFunc(UART_LPUART1,(char *)("SMS DONE"),30000);
				_4G_Status = Dio_ReadChannel(DioConf_DioChannel_PTB1_GPIO_IN_MCU_4G_STATUS);
				InitFunc();
				TcpSendTimeCounter = 0;
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
				break;
			}
			case PROCESS_TCP_IDLE: //״̬
			{
				UART_Receive_Data(UART_LPUART1, UartRecvPtr, &pReadLen, 100);//100ms
				if (SocketId < 0)
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_REGCHK);
				}
				else if (pReadLen>0)
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_RECV);
					RecvTimerDelay = TimerCounter;
				}
				else if (AppConfigInfo.eolFlg == 1 && TcpWorkState==0 && SendTimerFlg==true)
				{
					SendTimerFlg = false;
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_SEND);
				}
				if((TimerCounter-RecvTimerDelay)>=30000 && TcpWorkState==1)//10sû·
				{
					TcpWorkState = 0;
				}
				break;
			}
			case PROCESS_TCP_ATSYS:
			{
				sint8 ATRet = -1;
				AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet,100);
				if (ATRet == 0)
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
				}
				else
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
				}
				break;
			}
			case PROCESS_TCP_REGCHK: //פ飬SIMCPIN,ICCIDȡ
			{
				RegChkRet = TcpRegisterChkFunc();
				if (RegChkRet > 0) //ͨSIMѾѽפ
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_CONNECT);
				}
				else
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
				}
				break;
			}
			case PROCESS_TCP_CONNECT: //ӣת
			{
				if (SocketId < 0)
				{
					sint8 ConnectRet = 0;
					ConnectRet = TcpConnectFunc(&SocketId);
					if (ConnectRet > 0)
					{
						PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
					}
					else
					{
						PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
					}
				}
				break;
			}
			case PROCESS_TCP_SEND: //ݷ
			{
				sint8 SendRet = -1;
				SendRet = TcpDataSendFunc(SocketId);
				if (SendRet == 0)
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
					tcpErrorCounter = 0;
				}
				else
				{
					SocketId = -1;
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
				}
				break;
			}
			case PROCESS_TCP_RECV: //ݽ,100ms״̬¼ɽ
			{
	//			Dio_FlipChannel(DioConf_DioChannel_PTE0_GPIO_OUT_MCU_LED1);

				if (pReadLen > 0 && SocketId >= 0)
				{
					TcpDataInfoRecvHandle(UartRecvPtr, pReadLen);
				}
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
				break;
			}
			case PROCESS_TCP_HEART: //
			{
				break;
			}
			case PROCESS_TCP_SLEEP: //״̬
			{

				while(waitForSleepFlag == true)
				{
					Uart_4G_Task_Sleep_FLag = true;
					vTaskDelay(pdMS_TO_TICKS(1000));
				}
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_INIT);
				break;
			}
			case PROCESS_TCP_ERROR: //״̬
			{
				vTaskDelay(pdMS_TO_TICKS(1000));
				tcpErrorCounter++;
				if(tcpErrorCounter>60&&TcpSysReboot == 1)//޷פ
				{
					Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_ON);
					vTaskDelay(pdMS_TO_TICKS(2500));
					Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_OFF);
					vTaskDelay(pdMS_TO_TICKS(2500));
					tcpErrorCounter = 0;
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_INIT);
				}
				else
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
				}

				break;
			}
		}
	}
}
static void vTimer1000msCallback(TimerHandle_t pxTimer)
{
	uint32 ulTimerID;
	ulTimerID = (uint32)pvTimerGetTimerID(pxTimer);
	if(ulTimerID==0)
	{
		SendTimerFlg = true;
		TcpSendTimeCounter++;
	}
}
sint8 TcpDataSendFunc(sint8 ConnectId)
{
	sint8 outValue = -1;
	uint32 pSendDataAddr = 0;
	uint16 DataSendLen = 0;
	TcpDataEncode(&pSendDataAddr, &DataSendLen); //malloc,pSendDataָĵַ
	if (DataSendLen == 0)
	{
		return 0; //ʱݿԷ
	}
	outValue = tcpipConnectionSend(ConnectId, (uint8 *)pSendDataAddr, DataSendLen); //ͺ
	if (pSendDataAddr != 0)
	{
		vPortFree((uint8 *)(pSendDataAddr));
	}
	pSendDataAddr = 0;
	return outValue;
}
sint8 tcpipConnectionSend(uint8 TcpConnectId, uint8 *SendDataPtr, uint16 SendDataLen)
{
	sint8 outValue = -1;
	uint8  sendErrConuter= 0;
	uint16 ReadLen = 0;
	char AtCmdSend[30] = {0};
	uint8 AtCmdSendTotalLen = 0;
	uint8 UartRecvPtr[128];//ݴbufferĴ
	uint8 ret = 0;
	sprintf(AtCmdSend, "AT+CIPSEND=%d,%d\r\n", TcpConnectId, SendDataLen);
	AtCmdSendTotalLen = mstrlen(AtCmdSend);
	while(outValue!=0&&sendErrConuter<3)
	{
		ret = UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)AtCmdSend, AtCmdSendTotalLen, UartRecvPtr, &ReadLen, 1000);
		if (((ret==0)&&(ReadLen>0)&&((uint8 *)strstr((char *)UartRecvPtr, (char *)(">"))))||1)//IFĬͨ
		{
			UART_Send_Data(UART_LPUART1, (uint8 *)SendDataPtr, SendDataLen, 1000);
			sint8 ret = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CIPSEND"),2000);
			if (ret==0)
			{
				outValue = 0;
			}
			else
			{
				outValue = -2;
				sendErrConuter++;
			}
		}
		else
		{
			outValue = -1;
			sendErrConuter++;
		}
	}
	return outValue;
}
sint8 TcpConnectFunc(sint8 *ConnectId)
{
	uint8 ConnectStep = 1;
	sint8 ChkState = 0;
	sint8 ATRet = -1;
	uint8 UartRecvPtr[100];
	while (1)
	{
		switch (ConnectStep)
		{
		case 1: // ATָͬ
		{
			char *ATCmdSend = (char *)("ATE0\r\n");
			uint8 ATCmdSendLen = mstrlen(ATCmdSend);
			uint8 ReadLen = 0;
			UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen,UartRecvPtr, &ReadLen, pdMS_TO_TICKS(1000));
			uint8 *retptr = NULL;
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("OK"));
				if (retptr)
				{
					ConnectStep++;
				}
				else
				{
					ChkState = -ConnectStep;
					return ChkState;
				}
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 2: // Netopen
		{
			AtcmdTransmit(AT_NETOPEN, NULL, 0, &ATRet,100);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 3: //Ӽ
		{
			AtcmdTransmit(AT_CONNECTCHK, NULL, 0, &ATRet,1000); // ATretصֵidδӷ-1
			if (ATRet >= 0)
			{
				*ConnectId = ATRet;
				return 2;
			}
			else
			{
				ConnectStep++;
			}
			break;
		}
		case 4: //ת
		{
			char AtCmdSend[30] = {0};
			uint8 AtCmdSendLen = 0;
			AtCmdSendLen = mstrlen(WebSiteName);
			memcpy(AtCmdSend, WebSiteName, AtCmdSendLen);
			memcpy(AtCmdSend + AtCmdSendLen, (char *)CRLF, sizeof(CRLF));
			AtCmdSendLen = AtCmdSendLen + 2;
			AtcmdTransmit(AT_CGIP, (uint8 *)AtCmdSend, AtCmdSendLen, &ATRet,5000);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 5: //
		{
			char AtCmdSend[50] = {0};
			uint8 AtCmdSendTotalLen = 0;
			*ConnectId = 0;
			/*IPԸ*/
//			char *ATCmdSend = (char *)("\"120.26.68.165\"");
//			memset(WebSiteIp,0x00,sizeof(WebSiteIp));
//			memcpy(WebSiteIp ,ATCmdSend,strlen(ATCmdSend));
//			WebSitePort = 14401;
			/**/
			sprintf(AtCmdSend, "AT+CIPOPEN=%d,\"TCP\",%s,%d\r\n", *ConnectId, WebSiteIp, WebSitePort); //˴ҪŻ
			AtCmdSendTotalLen = mstrlen(AtCmdSend);
			UART_Send_Data(UART_LPUART1, AtCmdSend, AtCmdSendTotalLen, pdMS_TO_TICKS(100));
			ATRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CIPOPEN: 0,0"),20000);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				*ConnectId = -1;
				return ChkState;
			}
			break;
		}
		default:
			ChkState = ConnectStep;
			return ChkState;
		}
	}
}
sint8 TcpRegisterChkFunc(void)
{
	uint8 RegChkStep = 0;
	sint8 ChkState = 0; //ĬΪ0
	sint8 ATRet = -1;
	while (1)
	{
		switch (RegChkStep)
		{
		case 0: // ATָͬ
		{
			AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet,100);
			if (ATRet == 0)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		case 1: // CPIN
		{
			AtcmdTransmit(AT_SIMREADY, NULL, 0, &ATRet,100);
			if (ATRet == 0)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		case 2:
		{
			AtcmdTransmit(AT_CGREG, NULL, 0, &ATRet,1000); //פ飬ֵ15פɹ
			if (ATRet == 1 || ATRet == 5)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		default:
			ChkState = RegChkStep;
			return ChkState;
			break;
		}
	}
}
void InitFunc(void)
{
	// 4Gģʼ
	uint8 _4G_InitStep = 0;
	sint8 ATRet = -1;
	uint16 ReadLen = 0;
	char *ATCmdSend = NULL;
	uint8 ATCmdSendLen = 0;
	uint8 UartRecvPtr[50];
	uint16 ATerrorCnt = 0;
	uint8 *retptr = NULL;
	while (1)
	{
		switch (_4G_InitStep)
		{
		case 0: // ATָͬ
		{
			AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet,100);
			if (ATRet == 0)
			{
				ATerrorCnt = 0;
				_4G_InitStep++;
			}
			else
			{
				vTaskDelay(pdMS_TO_TICKS(1000));
				ATerrorCnt++;
				if(ATerrorCnt>60*5)
				{
					SystemSoftwareReset();
				}
			}
			break;
		}
		case 1: //رջ
		{
			ATCmdSend = (char *)("ATE0\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(10000));
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("OK"));
				if (retptr)
				{
					_4G_InitStep++;
				}
				else
				{
					_4G_InitStep=0;
				}
			}
			else
			{
				_4G_InitStep=0;
			}
			break;
		}
		case 2: // IMEIȡ
		{
			ATCmdSend = (char *)("AT+SIMEI?\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(1000));
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("+SIMEI"));
				if (retptr)
				{
					memcpy(ImeiNum, retptr + 8, 15);
					_4G_InitStep++;
				}
				else
				{
					_4G_InitStep=0;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 3: // ʱԶ
		{
			ATCmdSend = (char *)("AT+CTZU=1\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(1000));
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("OK"));
				if (retptr)
				{
					_4G_InitStep++;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 4: // ICCIDȡ
		{
			AtcmdTransmit(AT_GETICCID, NULL, 0, &ATRet,1000);
			if (ATRet == 0)
			{
				_4G_InitStep++;
			}
			else
			{
				_4G_InitStep=0;
			}
			break;
		}
		case 5:
		{
			ATCmdSend = (char *)("AT+CIPSENDMODE=0\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(100));
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("OK"));
				if (retptr)
				{
					_4G_InitStep++;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
		}
		default:
		{
			return;
			break;
		}
		}
	}
}
static void AtcmdTransmit(sint8 CmdIdx, uint8 *SetValuePtr, uint16 SetValueLen, sint8 *retFunc,uint16 timeout)
{
	uint16 ReadLen = 0;
	uint8 PtrATCmdSend[64];
	uint8 ATCmdFixedLen = 0;
	uint16 ATCmdTotalLen = 0;
	uint8 UartRecvPtr[256];
	ATCmdFixedLen = mstrlen(Atcmdfunc[CmdIdx].str);
	ATCmdTotalLen = ATCmdFixedLen + SetValueLen;
	memset(PtrATCmdSend, 0x00, ATCmdTotalLen + 1);
	memcpy(PtrATCmdSend, Atcmdfunc[CmdIdx].str, ATCmdFixedLen);
	if (SetValuePtr != NULL)
	{
		memcpy(&PtrATCmdSend[ATCmdFixedLen], SetValuePtr, SetValueLen);
	}
	UART_Query_Data(UART_LPUART1, UART_LPUART1, PtrATCmdSend, ATCmdTotalLen, UartRecvPtr, &ReadLen, timeout);
	if(ReadLen>0)
	{
		*retFunc = Atcmdfunc[CmdIdx].cb((char *)PtrATCmdSend, UartRecvPtr, CmdIdx, ReadLen);
	}
	else
	{
		*retFunc = -1;
	}
	return;
}
sint8 at_callbackFunc(char *PSendStr, char *pReadStr, uint8 CmdIdx, uint16 pReadLen)
{
	sint8 OutValue = -1;
	uint8 *retptr = NULL;
	char *OkAns = "OK";
	retptr = (uint8 *)strstr((char *)pReadStr, OkAns);
	switch (CmdIdx)
	{
	case AT_CMD_TEST:
	{
		if (retptr)
		{
			OutValue = 0;
		}
		break;
	}
	case AT_SIMREADY:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("READY"));
			if (retptr)
			{
				OutValue = 0;
			}
		}
		break;
	}
	case AT_GETICCID:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("ICCID:"));
			if (retptr)
			{
				memcpy(IccidNum, retptr + 7, 20);
				OutValue = 0;
			}
		}
		break;
	}
	case AT_CGREG:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("CGREG:"));
			if (retptr)
			{
				uint8 RegN = 0;
				uint8 RegState = 0;
				RegN = CharToHex(*(retptr + 7));
				RegState = CharToHex(*(retptr + 9));
				OutValue = (RegState + RegN);
				return OutValue;
			}
		}

		break;
	}
	case AT_NETOPEN:
	{
		if (retptr)
		{
			OutValue = 0;
		}
		retptr = (uint8 *)strstr((char *)pReadStr, (char *)("opened")); //ظ
		if (retptr)
		{
			OutValue = 0;
		}
		break;
	}
	case AT_CONNECTCHK:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("TCP"));
			if (retptr)
			{
				OutValue = CharToHex(*(retptr - 3));
				return OutValue;
			}
		}
		break;
	}
	case AT_CGIP:
	{
		if (retptr)
		{
			memset(WebSiteIp,0x00,sizeof(WebSiteIp));
			for (uint8 i = 0; i < 30; i++)
			{
				if (*(retptr - i) == ',')
				{
					memcpy(WebSiteIp, retptr - i + 1, i-5);
					OutValue = 0;
					break;
				}
			}
		}
		break;
	}
	case AT_CONNECT:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("CIPOPEN:"));
			if (retptr&&pReadLen>9)
			{
				SocketId = CharToHex(*(retptr + 9));
			}
			OutValue = 0;
		}
		break;
	}
	case AT_SEND:
	{
		retptr = (uint8 *)strstr((char *)pReadStr, (char *)(">"));
		if (retptr)
		{
			OutValue = 0;
		}
		else
		{
			OutValue = -1;
		}
		break;
	}
	default:
		break;
	}
	return OutValue;
}
void TcpDataEncode(uint32 *PtrSendAddr, uint16 *SendLen)
{
	static UTC8TimeType UTC8TimeTcp;
	uint8 *SendBuffer = NULL;
	uint8 DataIdx = 0;
	if ((TcpSendTimeCounter) % (10*60) == 5)
	{
		DataIdx = VerMsg; //汾Ϣ
	}
	else if (TcpSendTimeCounter % 10 == 1)
	{
		DataIdx = TruckBattMsg; //Ϣ
	}
	else if ((TcpSendTimeCounter ) % 60 == 2)
	{
		DataIdx = TruckVehiMsg; //Ϣ
	}
	else if ((TcpSendTimeCounter) % 60 == 3)
	{
		DataIdx = TruckAcclMsg; //ۼϢ
	}
	else if ((TcpSendTimeCounter) % 10 == 4)
	{
		DataIdx = GpsMsg; //λϢ
	}
	else if ((TcpSendTimeCounter) % (60*60*2) == 6)
	{
		DataIdx = 0x01; //ʱУ׼
	}
	else
	{
		*SendLen = 0;
		DataIdx = 0; //,
		return;
	}
	memcpy(TcpbattSN, AppConfigInfo.deviceSn, 17);
	GetUtc8Time(&UTC8TimeTcp); //ʱȡ
	vTaskDelay(pdMS_TO_TICKS(100));
	switch (DataIdx)
	{
	case 0x01://ʱУ׼
	{
		char *ATCmdSend = (char *)("AT+CNTP\r\n");
		uint8 ATCmdSendLen = mstrlen(ATCmdSend);
		uint8 ReadLen = 0;
		uint8 UartRecvPtr[20];
		UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)ATCmdSend, ATCmdSendLen,UartRecvPtr, &ReadLen, pdMS_TO_TICKS(500));
		*SendLen = 0;//ͣΪ0
		return;
	}
	case 0x82:
	{
		GPSInfo GpsRecvData;
		GPSMsgtoTcpType GpsToTcpInfo;
		*SendLen = sizeof(GpsToTcpInfo);
		SendBuffer = pvPortMalloc(*SendLen);
		uint16 tac = 0;
		uint32 cellId = 0;
		uint8 DataLen = (uint16)sizeof(GpsToTcpInfo.gpsInfo);
		GpsToTcpInfo.startSymbol[0] = TCP_START_SYM1;
		GpsToTcpInfo.startSymbol[1] = TCP_START_SYM2;
		GpsToTcpInfo.cmdSymbol = TCP_CMD_SYM;
		GpsToTcpInfo.ansSymbol = TCP_ANS_SYM;
		memcpy(GpsToTcpInfo.SN, TcpbattSN, BATT_SN_LEN);
		GpsToTcpInfo.encryptMethod = TCP_ENCPT_DISABLE; // not encrypt
		GpsToTcpInfo.dataLength[0] = (DataLen >> 8) & 0xFF;
		GpsToTcpInfo.dataLength[1] = DataLen & 0xFF;
		GpsToTcpInfo.gpsInfo.sendTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		GpsToTcpInfo.gpsInfo.sendTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	 // month
		GpsToTcpInfo.gpsInfo.sendTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	 // day
		GpsToTcpInfo.gpsInfo.sendTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	 // hour
		GpsToTcpInfo.gpsInfo.sendTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		GpsToTcpInfo.gpsInfo.sendTimeUTC[5] = UTC8TimeTcp.second & 0xFF; // sec
		GpsToTcpInfo.gpsInfo.msgMark = DataIdx;
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[1] = UTC8TimeTcp.month & 0xFF;  // month
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	  // day
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	  // hour
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[5] = UTC8TimeTcp.second & 0xFF;
		if (xQueueReceive(GpsDataQueueHandle, &GpsRecvData, 0) == pdPASS)
		{
			memcpy((uint8 *)&GpsToTcpInfo.gpsInfo.GpsInfoData, (uint8 *)&GpsRecvData, sizeof(GPSInfo));
		}
		else
		{
			memset((uint8 *)&GpsToTcpInfo.gpsInfo.GpsInfoData, 0x00, sizeof(GPSInfo));
		}
		GpsToTcpInfo.gpsInfo.Tac[0] = tac >> 8;
		GpsToTcpInfo.gpsInfo.Tac[1] = tac & 0xFF;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 24;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 16;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 8;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId;
		uint16 xyzDatacache[3] = {0};
		memcpy(xyzDatacache, xyzData, 3*sizeof(uint16));
		for (uint8 i = 0; i < 3; i++)
		{
			if (xyzDatacache[i] > 0x8000) // Ϊ
			{
				xyzDatacache[i] = 20000U + (sint16)xyzDatacache[i];
			}
			else
			{
				xyzDatacache[i] = xyzDatacache[i] + 20000U;
			}
		}
		GpsToTcpInfo.gpsInfo.xData[0] = xyzDatacache[0] >> 8;
		GpsToTcpInfo.gpsInfo.xData[1] = xyzDatacache[0];
		GpsToTcpInfo.gpsInfo.yData[0] = xyzDatacache[1] >> 8;
		GpsToTcpInfo.gpsInfo.yData[1] = xyzDatacache[1];
		GpsToTcpInfo.gpsInfo.zData[0] = xyzDatacache[2] >> 8;
		GpsToTcpInfo.gpsInfo.zData[1] = xyzDatacache[2];
		GpsToTcpInfo.CRC = bcc_chk((uint8 *)&GpsToTcpInfo, sizeof(GPSMsgtoTcpType) - 1);
		memcpy(SendBuffer, &GpsToTcpInfo, sizeof(GpsToTcpInfo));
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x86:
	{
		VersionMsgtoTcpType VerMsgToTcpInfo;
		*SendLen = sizeof(VersionMsgtoTcpType);
		SendBuffer = pvPortMalloc(*SendLen);
		uint16 DataLen = 0;
		DataLen = (uint16)sizeof(VerMsgToTcpInfo.VerInfo);
		VerMsgToTcpInfo.startSymbol[0] = TCP_START_SYM1;
		VerMsgToTcpInfo.startSymbol[1] = TCP_START_SYM2;
		VerMsgToTcpInfo.cmdSymbol = TCP_CMD_SYM;
		VerMsgToTcpInfo.ansSymbol = TCP_ANS_SYM;
		memcpy(VerMsgToTcpInfo.SN, TcpbattSN, BATT_SN_LEN);
		VerMsgToTcpInfo.encryptMethod = TCP_ENCPT_DISABLE; // not encrypt
		VerMsgToTcpInfo.dataLength[0] = (DataLen >> 8) & 0xFF;
		VerMsgToTcpInfo.dataLength[1] = DataLen & 0xFF;
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	// month
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	// day
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	// hour
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[5] = UTC8TimeTcp.second & 0xFF; // sec
		VerMsgToTcpInfo.VerInfo.msgMark = DataIdx;
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	 // month
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	 // day
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	 // hour
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[5] = UTC8TimeTcp.second & 0xFF;
		memcpy(VerMsgToTcpInfo.VerInfo.ICCID, IccidNum, 20);
		memcpy(VerMsgToTcpInfo.VerInfo.IMEI, ImeiNum, 15);
		VerMsgToTcpInfo.VerInfo.BMSHwVersion[0] = BMS_HardwareVersion >> 8;
		VerMsgToTcpInfo.VerInfo.BMSHwVersion[1] = BMS_HardwareVersion;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[0] = BMS_SoftwareVersion >> 24;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[1] = BMS_SoftwareVersion >> 16;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[2] = BMS_SoftwareVersion >> 8;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[3] = BMS_SoftwareVersion;
		VerMsgToTcpInfo.VerInfo.HwVersion[0] = (HwVersion >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.HwVersion[1] = (HwVersion)&0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[0] = (BlSwVersion >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[1] = (BlSwVersion >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[2] = (BlSwVersion >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[3] = (BlSwVersion)&0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[0] = (DrvSwVersion >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[1] = (DrvSwVersion >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[2] = (DrvSwVersion >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[3] = (DrvSwVersion)&0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[0] = (AppSwVersion >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[1] = (AppSwVersion >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[2] = (AppSwVersion >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[3] = (AppSwVersion)&0xFF;
		VerMsgToTcpInfo.VerInfo.BmsType = BmsManuFacture;
		VerMsgToTcpInfo.VerInfo.BmsInfo = BmsInfo;
		VerMsgToTcpInfo.VerInfo.DataModuleType = DataModuleType;
		VerMsgToTcpInfo.CRC = bcc_chk((uint8 *)&VerMsgToTcpInfo, sizeof(VerMsgToTcpInfo) - 1);
		memcpy(SendBuffer, &VerMsgToTcpInfo, sizeof(VersionMsgtoTcpType));
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x90:
	{
		*SendLen = 0x52;
		SendBuffer = pvPortMalloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x39;							   // 57
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF);	   // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF); // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);	// uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);	// uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);	// uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF); // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF); // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);			// uint8	BATTMSG
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF); // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);	// uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);	// uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);	// uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF); // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF); // uint8	second
		memcpy(SendBuffer + 0x25, VIN, 17);
		*(SendBuffer + 0x36) = (vehicleStatus & 0xFF);		 // uint8	״̬
		if(BMS_Mode == 1)
		{
			bmsHVOn = 1;
		}
		else if(BMS_Mode == 2)
		{
			bmsHVOn = 0;
		}
		else
		{
			bmsHVOn = 0xFF;
		}
		*(SendBuffer + 0x37) = (bmsHVOn & 0xFF);			 // uint8	bmsϸѹָ
		*(SendBuffer + 0x38) = (currentGearPosition & 0xFF); // uint8	ǰλ
		*(SendBuffer + 0x39) = (parkingBreakStatus & 0xFF);	 // uint8	ɲź
		*(SendBuffer + 0x3A) = (breakingStatus & 0xFF);		 // uint8	ƶ
		*(SendBuffer + 0x3B) = ((ODO >> 24) & 0xFF);		 // uint32	
		*(SendBuffer + 0x3C) = ((ODO >> 16) & 0xFF);
		*(SendBuffer + 0x3D) = ((ODO >> 8) & 0xFF);
		*(SendBuffer + 0x3E) = (ODO & 0xFF);
		*(SendBuffer + 0x3F) = (dcdcWorkStatus & 0xFF);			   // uint8 DCDC״̬
		*(SendBuffer + 0x40) = (numOfChrgableSubsys & 0xFF);	   // uint8	ɳϵͳ
		*(SendBuffer + 0x41) = (chrgableSubsysCode & 0xFF);		   // uint8	ɳ索ϵͳ
		*(SendBuffer + 0x42) = (BMS_MaxCellTempCSC & 0xFF);		   // uint8	¶ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x43) = (BMS_MaxCellTempNum & 0xFF);		   // uint8	¶̽뵥 _1ƫ_0λ_
		*(SendBuffer + 0x44) = (BMS_MinCellTempCSC & 0xFF);		   // uint8	¶ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x45) = (BMS_MinCellTempNum & 0xFF);		   // uint8	¶̽ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x46) = (BMS_MaxCellVoltCSC & 0xFF);		   // uint8	ߵѹϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x47) = ((BMS_MaxCellVoltNum >> 8) & 0xFF); // uint16	ߵѹص _1ƫ_0λ_
		*(SendBuffer + 0x48) = (BMS_MaxCellVoltNum & 0xFF);
		*(SendBuffer + 0x49) = (BMS_MinCellVoltCSC & 0xFF);		   // uint8	͵ѹϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x4A) = ((BMS_MinCellVoltNum >> 8) & 0xFF); // uint16	͵ѹص _1ƫ_0λ_
		*(SendBuffer + 0x4B) = (BMS_MinCellVoltNum & 0xFF);
		*(SendBuffer + 0x4C) = (ebcStatus & 0xFF); // uint8 ״̬
		*(SendBuffer + 0x4D) = (uint8)((ebcAskHVOn & 0x01) | ((ebcAskHVOff & 0x01) << 1) | ((retainLockSignal & 0x01) << 3) | ((dischargeLockSignal & 0x01) << 5) | ((chargeLockSignal & 0x01) << 6));
		*(SendBuffer + 0x4E) = (chargeFlag & 0xFF);		 // uint8 ־λ
		*(SendBuffer + 0x4F) = ((vcuDCVol >> 8) & 0xFF); // uint16 ֱĸߵѹ
		*(SendBuffer + 0x50) = (vcuDCVol & 0xFF);
		*(SendBuffer + 0x51) = bcc_chk(SendBuffer, 0x51);
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x91:
	{
		GetCSQValue(&CSQValue);
		if (BMS_Mode == 1)
		{
			BMS_Mode = 2;
		}
		else if(BMS_Mode == 2)
		{
			BMS_Mode = 3;
		}
		else
		{
			BMS_Mode = 1;
		}
		*SendLen = 0x54 + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2 + min(BMS_TempTotal,BMS_TEMP_MAX_NUM);
		SendBuffer = pvPortMalloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x3B + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2 + min(BMS_TempTotal,BMS_TEMP_MAX_NUM);
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF);	   // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);	   // uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);	   // uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);	   // uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);	   // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);	   // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);			   // uint8	BATTMSG
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF);	   // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);	   // uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);	   // uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);	   // uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);	   // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);	   // uint8	second
		*(SendBuffer + 0x25) = (CSQValue & 0xFF);			   // uint8	csq
		*(SendBuffer + 0x26) = (BMS_Mode & 0xFF);			   // uint8	عϵͳ״̬0-ʼ 1-Լϵ 2-״̬ 3-ѹж 4-״̬_1ƫ_0λ_
		*(SendBuffer + 0x27) = (BMS_CharGunSt & 0xFF);		   // uint8	ֱǹ״̬0-δ 1-ǹ 2-˫ǹ 3-Ч_1ƫ_0λ_
		*(SendBuffer + 0x28) = (BMS_FtLvl & 0xFF);			   // uint8	ǰ߹ϵȼ0- 1-1 ΢ 2-2 ع 3-3 عϣ_1ƫ_0λ_
		*(SendBuffer + 0x29) = (BMS_FtCode & 0xFF);			   // uint8	룬BMS_ErrCode_1ƫ_0λ_
		*(SendBuffer + 0x2A) = (BMS_ReqHVOff & 0xFF);		   // uint8	BMS¸ѹ0-Ч 1-¸ѹ 2-¸ѹ 3-Ч_1ƫ_0λ_
		*(SendBuffer + 0x2B) = (BMS_CharSt & 0xFF);			   // uint8	״̬0-δ 1- 2- 3-ϣ_1ƫ_0λ_
		*(SendBuffer + 0x2C) = (BMS_PackSOC & 0xFF);		   // uint8	ذSOC _0.4ƫ_0λ_
		*(SendBuffer + 0x2D) = (BMS_PackSOH / 25 * 10) & 0xFF; // SOH 1%
		*(SendBuffer + 0x2E) = (BMS_BattVolt >> 8) & 0xFF;	   //ذܵѹ
		*(SendBuffer + 0x2F) = (BMS_BattVolt & 0xFF);
		*(SendBuffer + 0x30) = ((BMS_PackCurr >> 8) & 0xFF); // uint16	ذܵΪֵŵΪֵ _0.1ƫ_-1000λ_A
		*(SendBuffer + 0x31) = (BMS_PackCurr & 0xFF);
		*(SendBuffer + 0x32) = ((BMS_SysInsRes >> 8) & 0xFF); // uint16	ϵͳԵ _1ƫ_0λ_K
		*(SendBuffer + 0x33) = (BMS_SysInsRes & 0xFF);
		/*28 Byte ̵״̬*/
		*(SendBuffer + 0x34) = (BMS_StPosRly & 0xFF);	   // uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x35) = (BMS_StPreCharRly & 0xFF);  // uint8	Ԥ̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x36) = (BMS_StNegRly & 0xFF);	   // uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x37) = 0;						   // һ
		*(SendBuffer + 0x38) = 0;						   // PTC
		*(SendBuffer + 0x39) = 0;						   // յ
		*(SendBuffer + 0x3A) = (BMS_StPosCharRly1 & 0xFF); // uint8	̵ֱ1״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3B) = (BMS_StNegCharRly1 & 0xFF); // uint8	ֱ为̵1״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3C) = (BMS_StPosCharRly2 & 0xFF); // uint8	̵ֱ2״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3D) = (BMS_StNegCharRly2 & 0xFF); // uint8	ֱ为̵2״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3E) = (BMS_StPosHeatRly & 0xFF);  // uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3F) = (BMS_StNegHeatRly & 0xFF);  // uint8	ȸ̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x40) = 0;
		/*28-Byte̵״̬*/
		*(SendBuffer + 0x50) = ((BMS_CellTotal >> 8) & 0xFF); // uint16	PACKеоĿ
		*(SendBuffer + 0x51) = (BMS_CellTotal & 0xFF);
		for (uint16 index = 0; index < min(BMS_CellTotal,BMS_CELL_MAX_NUM); index++)
		{
			*(SendBuffer + 0x52 + index * 2) = ((BMS_CellVolt[index] >> 8) & 0xFF);
			*(SendBuffer + 0x52 + index * 2 + 1) = ((BMS_CellVolt[index]) & 0xFF);
		}
		*(SendBuffer + 0x52 + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2) = (BMS_TempTotal & 0xFF); //  uint8	PACKео¶ȵ(̽)Ŀ
		memcpy(SendBuffer + 0x53 + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2, BMS_CellTemp, min(BMS_TempTotal,BMS_TEMP_MAX_NUM));
		*(SendBuffer + 0x53 + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2 + min(BMS_TempTotal,BMS_TEMP_MAX_NUM)) = bcc_chk(SendBuffer, 0x53 + min(BMS_CellTotal,BMS_CELL_MAX_NUM)*2 + min(BMS_TempTotal,BMS_TEMP_MAX_NUM));
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x92:
	{
		*SendLen = 0x4E;
		SendBuffer = pvPortMalloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x35;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF);		   // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);		   // uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);		   // uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);		   // uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);		   // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);		   // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);				   // uint8
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF);		   // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);		   // uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);		   // uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);		   // uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);		   // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);		   // uint8	second
		*(SendBuffer + 0x25) = ((BMS_TotalCharCapy >> 24) & 0xFF); // uint32	ۻAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x26) = ((BMS_TotalCharCapy >> 16) & 0xFF);
		*(SendBuffer + 0x27) = ((BMS_TotalCharCapy >> 8) & 0xFF);
		*(SendBuffer + 0x28) = (BMS_TotalCharCapy & 0xFF);
		*(SendBuffer + 0x29) = ((BMS_TotalDisCharCapy >> 24) & 0xFF); // uint32	ۻųAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x2A) = ((BMS_TotalDisCharCapy >> 16) & 0xFF);
		*(SendBuffer + 0x2B) = ((BMS_TotalDisCharCapy >> 8) & 0xFF);
		*(SendBuffer + 0x2C) = (BMS_TotalDisCharCapy & 0xFF);
		*(SendBuffer + 0x2D) = ((BMS_TotalCharEngy >> 24) & 0xFF); // uint32	ۼƳkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x2E) = ((BMS_TotalCharEngy >> 16) & 0xFF);
		*(SendBuffer + 0x2F) = ((BMS_TotalCharEngy >> 8) & 0xFF);
		*(SendBuffer + 0x30) = (BMS_TotalCharEngy & 0xFF);
		*(SendBuffer + 0x31) = ((BMS_TotalDisCharEngy >> 24) & 0xFF); // uint32	ۼƷųkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x32) = ((BMS_TotalDisCharEngy >> 16) & 0xFF);
		*(SendBuffer + 0x33) = ((BMS_TotalDisCharEngy >> 8) & 0xFF);
		*(SendBuffer + 0x34) = (BMS_TotalDisCharEngy & 0xFF);
		*(SendBuffer + 0x35) = ((BMS_TotalBackCharCapy >> 24) & 0xFF); // uint32	ۼƶܻAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x36) = ((BMS_TotalBackCharCapy >> 16) & 0xFF);
		*(SendBuffer + 0x37) = ((BMS_TotalBackCharCapy >> 8) & 0xFF);
		*(SendBuffer + 0x38) = (BMS_TotalBackCharCapy & 0xFF);
		*(SendBuffer + 0x39) = ((BMS_TotalBackCharEngy >> 24) & 0xFF); // uint32	ۼƶܻkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x3A) = ((BMS_TotalBackCharEngy >> 16) & 0xFF);
		*(SendBuffer + 0x3B) = ((BMS_TotalBackCharEngy >> 8) & 0xFF);
		*(SendBuffer + 0x3C) = (BMS_TotalBackCharEngy & 0xFF);
		*(SendBuffer + 0x3D) = ((BMS_TotalStaCharCapy >> 24) & 0xFF); // uint32	ۼƻվAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x3E) = ((BMS_TotalStaCharCapy >> 16) & 0xFF);
		*(SendBuffer + 0x3F) = ((BMS_TotalStaCharCapy >> 8) & 0xFF);
		*(SendBuffer + 0x40) = (BMS_TotalStaCharCapy & 0xFF);
		*(SendBuffer + 0x41) = ((BMS_TotalStaCharEngy >> 24) & 0xFF); // uint32	ۼƻվkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x42) = ((BMS_TotalStaCharEngy >> 16) & 0xFF);
		*(SendBuffer + 0x43) = ((BMS_TotalStaCharEngy >> 8) & 0xFF);
		*(SendBuffer + 0x44) = (BMS_TotalStaCharEngy & 0xFF);
		*(SendBuffer + 0x45) = ((BMS_TotalGunCharCapy >> 24) & 0xFF); // uint32	ۼƲǹAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x46) = ((BMS_TotalGunCharCapy >> 16) & 0xFF);
		*(SendBuffer + 0x47) = ((BMS_TotalGunCharCapy >> 8) & 0xFF);
		*(SendBuffer + 0x48) = (BMS_TotalGunCharCapy & 0xFF);
		*(SendBuffer + 0x49) = ((BMS_TotalGunCharEngy >> 24) & 0xFF); // uint32	ۼƲǹkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x4A) = ((BMS_TotalGunCharEngy >> 16) & 0xFF);
		*(SendBuffer + 0x4B) = ((BMS_TotalGunCharEngy >> 8) & 0xFF);
		*(SendBuffer + 0x4C) = (BMS_TotalGunCharEngy & 0xFF);
		*(SendBuffer + 0x4D) = bcc_chk(SendBuffer, 0x4D);
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	default:
		break;
	}
}
void GetUtc8Time(UTC8TimeType *UTC8TimeTcp)
{
	char *AtCmdAsk = (char *)("AT+CCLK?\r\n");
	uint8 AtCmdLen = mstrlen(AtCmdAsk);
	uint16 ReadLen = 0;
	uint8 *retptr = NULL;
	uint8 UartRecvPtr[128];
	UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)AtCmdAsk, AtCmdLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(100));
	if (ReadLen > 0)
	{
		if ((uint8 *)strstr((char *)UartRecvPtr, (char *)("OK")))
		{
			retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("+CCLK:"));
			if(retptr)
			{
				UTC8TimeTcp->year = CharToHex(*(retptr + 8)) * 10 + CharToHex(*(retptr + 9));
				UTC8TimeTcp->month = CharToHex(*(retptr + 11)) * 10 + CharToHex(*(retptr + 12));
				UTC8TimeTcp->day = CharToHex(*(retptr + 14)) * 10 + CharToHex(*(retptr + 15));
				UTC8TimeTcp->hour = CharToHex(*(retptr + 17)) * 10 + CharToHex(*(retptr + 18));
				UTC8TimeTcp->minute = CharToHex(*(retptr + 20)) * 10 + CharToHex(*(retptr + 21));
				UTC8TimeTcp->second = CharToHex(*(retptr + 23)) * 10 + CharToHex(*(retptr + 24));
			}
		}
	}
}
static void GetCSQValue(uint8 *out)
{
	char *AtCmdAsk = (char *)("AT+CSQ\r\n");
	uint8 AtCmdLen = mstrlen(AtCmdAsk);
	uint16 ReadLen = 0;
	uint8 *retptr = NULL;
	uint8 UartRecvPtr[30];
	UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)AtCmdAsk, AtCmdLen, UartRecvPtr, &ReadLen, pdMS_TO_TICKS(100));
	*out = 99;
	if (ReadLen > 0)
	{
		if ((uint8 *)strstr((char *)UartRecvPtr, (char *)("OK")))
		{
			*out = 0;
			retptr = (uint8 *)strstr((char *)UartRecvPtr, (char *)("+CSQ:"));
			char CsqStr[5];
			for (uint8 i = 0; i < 5; i++)
			{
				if (*(retptr+i+6) == ',')
				{
					break;
				}
				memcpy((CsqStr+i),(retptr+i+6),1);
			}
			*out = atoi(CsqStr);
		}
	}
	return;
}
static void TcpDataInfoRecvHandle(uint8 *DataRecv, uint16 DataRecvLen)
{
	uint8 Tcp_Cmd;
	uint8 *Ptr = NULL, *retptr = NULL;
	uint8 TcpCmdAnswer[50]={0};
	uint16 TcpDataLen = 0;
	uint16 NumCalTemp = 1;
	retptr = (uint8 *)strstr((char *)DataRecv, (char *)("\r\n##"));
	if (retptr == NULL||DataRecvLen<5)
		return;
	for (uint8 i = 0; i < 5; i++)
	{
		if (*(retptr - i - 1) == 'D')
		{
			break;
		}
		TcpDataLen = TcpDataLen + CharToHex(*(retptr - i - 1)) * NumCalTemp;
		NumCalTemp = NumCalTemp * 10;
	}
	if (TcpDataLen > 0)
	{
		Ptr = retptr + 2;
		if ((*(Ptr + 0) == TCP_START_SYM1) && (*(Ptr + 1) == TCP_START_SYM2)) //ʼϢ
		{
			Tcp_Cmd = *(Ptr + 2); //־
			if (*(Ptr + 3) == 0xFE)
			{
				TcpWorkState = 0x01;//ҪͣͣӦı־
			}
			else
			{
				return;
			}
			switch (Tcp_Cmd)
			{
			case TCP_QUERY_SYM:
				break;
			case TCP_SETCMD_SYM:
				break;
			case TCP_CONCMD_SYM:
			{
				TcpCmdAnswer[0] = TCP_START_SYM1;
				TcpCmdAnswer[1] = TCP_START_SYM1;
				TcpCmdAnswer[2] = TCP_CONCMD_SYM;
				if (*(Ptr + 30) == 0x83) //Զָ
				{
                    TcpCmdAnswer[3] = 0x01;
                    memcpy(&TcpCmdAnswer[4], (Ptr + 4), BATT_SN_LEN);
                    TcpCmdAnswer[21] = TCP_ENCPT_DISABLE;
                    TcpCmdAnswer[22] = 0x00;
                    TcpCmdAnswer[23] = 0x06;
                    memcpy(&TcpCmdAnswer[24], (Ptr + 24), 6);
                    TcpCmdAnswer[30] = bcc_chk(TcpCmdAnswer, 30);
					tcpipConnectionSend(SocketId, TcpCmdAnswer, 31);

					Fota_Process_Going = true;
					vTaskDelay(pdMS_TO_TICKS(5000));
					Fota_Ftp(Ptr + 32);
					Fota_Process_Going = false;
				}
                else if (*(Ptr + 30) == 0x80) //Զ
                {
                    TcpCmdAnswer[3] = 0x01;
                    memcpy(&TcpCmdAnswer[4], (Ptr + 4), BATT_SN_LEN);
                    TcpCmdAnswer[21] = TCP_ENCPT_DISABLE;
                    TcpCmdAnswer[22] = 0x00;
                    TcpCmdAnswer[23] = 0x06;
                    memcpy(&TcpCmdAnswer[24], (Ptr + 24), 6);
                    TcpCmdAnswer[30] = bcc_chk(TcpCmdAnswer, 30);
                    if (*(Ptr + 31) == 0x01) // 0x01
                    {
//                    	battSeparateEnable = 1;
//                    	battSeparateCtlState = 1;
                        tcpipConnectionSend(SocketId, TcpCmdAnswer, 31 );
                    }
                    else if (*(Ptr + 31) == 0x02) // 0x02
                    {
//                    	battSeparateEnable = 1;
//                    	battSeparateCtlState = 0;
                        tcpipConnectionSend(SocketId, TcpCmdAnswer, 31);
                    }
                }
				else
				{
					TcpCmdAnswer[3] = 0x0f;
					memcpy(&TcpCmdAnswer[4], (Ptr + 4), BATT_SN_LEN);
					TcpCmdAnswer[21] = TCP_ENCPT_DISABLE;
					TcpCmdAnswer[22] = 0x00;
					TcpCmdAnswer[23] = 0x06;
					memcpy(&TcpCmdAnswer[24], (Ptr + 24), 6);
					TcpCmdAnswer[30] = bcc_chk(TcpCmdAnswer, 30);
					tcpipConnectionSend(SocketId, TcpCmdAnswer, 31);
				}
				break;
            }
			case TCP_UDSCMD_SYM:
			{
				TcpCmdAnswer[0] = TCP_START_SYM1;
				TcpCmdAnswer[1] = TCP_START_SYM1;
				TcpCmdAnswer[2] = TCP_UDSCMD_SYM;
				tcpUdsFunc(Ptr,TcpCmdAnswer);
//				tcpipConnectionSend(SocketId, TcpCmdAnswer, 30);
				break;
			}
            default:
            {
                break;
            }
            }
        }
    }
}
void tcpUdsFunc(uint8 *Ptr,uint8 *AnsPtr)
{
	uint8 contrlType = 0;
	uint16 udsDataLen = 0;
	uint16 DIDBuffer = 0;
	uint8 udsType_SID = 0;
	uint8 DataBuffer[10];
	contrlType = *(Ptr + 30);
	udsDataLen = *(Ptr + 31);
	udsType_SID = *(Ptr + 32);
	DIDBuffer = *(Ptr + 33)<<8|*(Ptr + 34);
	memcpy(DataBuffer,Ptr + 35,udsDataLen);
	switch(contrlType)
	{
	case 0x00:
	{
		break;
	}
	case 0x01:
	{
		switch(udsType_SID)
		{
		case 0x2E:
		{
			switch(DIDBuffer)
			{
			case 0x01:
			{
//            	battSeparateEnable = 1;
				if(DataBuffer[0]==0x01)
				{
//					battSeparateCtlState = 1;
				}
				else if(DataBuffer[0]==0x00)
				{
//					battSeparateCtlState = 0;
				}
				*(AnsPtr+3) = 0x0f;
				memcpy((AnsPtr+4), (Ptr + 4), BATT_SN_LEN);
				*(AnsPtr+21) = TCP_ENCPT_DISABLE;
				*(AnsPtr+22) = 0x00;
				*(AnsPtr+23) = 0x06;
				memcpy((AnsPtr+24), (Ptr + 24), 6);
				*(AnsPtr+30) = contrlType;
				*(AnsPtr+31) = udsDataLen;
				*(AnsPtr+32) = udsType_SID;
				*(AnsPtr+33) = DIDBuffer>>8;
				*(AnsPtr+34) = DIDBuffer;
				*(AnsPtr+36) = DataBuffer[0];
				*(AnsPtr+37) = bcc_chk(AnsPtr, 37);
				return;
				break;
			}
			default:
				break;
			}
			break;
		}
		case 0x22:
		{
			break;
		}
		default:
			break;
		}
		break;
	}
	default:
		break;
	}
	*(AnsPtr+3) = 0x0f;
	memcpy((AnsPtr+4), (Ptr + 4), BATT_SN_LEN);
	*(AnsPtr+21) = TCP_ENCPT_DISABLE;
	*(AnsPtr+22) = 0x00;
	*(AnsPtr+23) = 0x06;
	memcpy((AnsPtr+24), (Ptr + 24), 6);
	*(AnsPtr+30) = contrlType;
	*(AnsPtr+31) = udsDataLen;
	*(AnsPtr+32) = 0x7F;
	*(AnsPtr+33) = DIDBuffer>>8;
	*(AnsPtr+34) = DIDBuffer;
	*(AnsPtr+36) = 0x31;
	*(AnsPtr+37) = bcc_chk(AnsPtr, 37);
}
void Fota_Ftp(uint8 *dataPtrIn)
{
	static uint8 ftp_process = 0;
	char *ATCmdSend = NULL;
	sint8 recvRet = -1;
	char ATSendDataBuffer[100] = {0};
	uint8 UartRecvBuffer[50];
	uint16 ReadLen = 0;
	uint8 *retptr = NULL;
//	char temp[70]=",qx,qx900,120.27.243.131,21,0,0.0.1.5,0.0.1.5,/Debug/V0.0.1.5.bin,";
	/*URLϢ*/
	char *databuffer[20];
	char *accountPtr;
	char *passwordPtr;
	char *ftpServerIpPtr;
	char *ftpServerPort;
	char *filePathPtr;
	char *filenamePtr;
	char keyFilename[20]={0};
	char *p = NULL;
	p = strtok((char *)dataPtrIn, ",");
	uint8 index = 0;
	boolean ftp_EndFlg = false;

	while (p&&index<20)
	{
		databuffer[index] = p;
		p = strtok(NULL, ",");//Ӳ
		index++;
	}
	accountPtr = databuffer[0];
	passwordPtr = databuffer[1];
	ftpServerIpPtr = databuffer[2];
	ftpServerPort = databuffer[3];
	filePathPtr = databuffer[7];
	for(sint8 i=strlen(filePathPtr);i--;i<0)
	{
		if(*(filePathPtr+i)=='/')
		{
			*(filePathPtr+i) = 0;
			filenamePtr = filePathPtr+i+1;
			break;
		}

	}
	memcpy(keyFilename,filenamePtr,mstrlen(filenamePtr)-3);
	memcpy(&keyFilename[mstrlen(filenamePtr)-3],"zl",strlen("zl"));
	while(!ftp_EndFlg)
	{
		vTaskDelay(pdMS_TO_TICKS(100));
		switch(ftp_process)
		{
		case 0://start
		{
			ATCmdSend = (char *)("AT+CFTPSSTART\r\n");
			UART_Send_Data(UART_LPUART1, ATCmdSend, mstrlen(ATCmdSend), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CFTPSSTART: 0"),2000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_EndFlg=1;
			}
			break;
		}
		case 1://login
		{
			memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
			sprintf(ATSendDataBuffer, "AT+CFTPSLOGIN=\"%s\",%s,\"%s\",\"%s\",0\r\n", ftpServerIpPtr, ftpServerPort,accountPtr,passwordPtr);
			UART_Send_Data(UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CFTPSLOGIN: 0"),30000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_EndFlg=1;
			}
			break;
		}
		case 2://transmit bin file from server to module
		{
			uint8 *UartData = NULL;
			memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
			sprintf(ATSendDataBuffer, "AT+CFTPSGETFILE=\"%s/%s\"\r\n", filePathPtr,filenamePtr);
			UART_Send_Data(UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CFTPSGETFILE: 0"),10000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_EndFlg=1;
			}
			break;
		}
		case 3://transmit zl file from server to module
		{
			memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
			sprintf(ATSendDataBuffer, "AT+CFTPSGETFILE=\"%s/%s\"\r\n", filePathPtr,keyFilename);
			UART_Send_Data(UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CFTPSGETFILE: 0"),10000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_EndFlg=1;
			}
			break;
		}
		case 4://logout
		{
			ATCmdSend = (char *)("AT+CFTPSLOGOUT\r\n");
			UART_Send_Data(UART_LPUART1, ATCmdSend, mstrlen(ATCmdSend), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("+CFTPSLOGOUT: 0"),2000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_process++;
			}
			break;
		}
		case 5://stop
		{
			ATCmdSend = (char *)("AT+CFTPSSTOP\r\n");
			UART_Send_Data(UART_LPUART1, ATCmdSend, mstrlen(ATCmdSend), pdMS_TO_TICKS(100));
			recvRet = AtcmdDelayRecvFunc(UART_LPUART1,(char *)("CFTPSSTOP: 0"),2000);
			if(recvRet==0)
			{
				ftp_process++;
			}
			else
			{
				ftp_process++;
			}
			break;
		}
		case 6://get data from module
		{
			char findDataBuffer[25] = {0};
			uint32 currentAddr = 0;
			uint16 readLenAsk = 256;
	        uint16 FotaRecvDataLen_8 = 0;
			uint32 fileLen = 65535;
	        uint32 FlashAddStart = 0;
	        uint32 appReceviedCRC;
	        uint16 getDataLenErrCount = 0;
	        uint8 UartData[512] = {0};
	        uint8 FlashData[512] = {0};
	        uint8 *fileDataPtr = NULL;
	        memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
			sprintf(ATSendDataBuffer, "AT+CFTRANTX=\"c:/%s\"\r\n",keyFilename);
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), UartRecvBuffer, &ReadLen, pdMS_TO_TICKS(5000));
			if (ReadLen == (4+45))
			{
				retptr = (uint8 *)strstr((char *)UartRecvBuffer, (char *)("+CFTRANTX: DATA"));
				if (retptr)
				{
					fileLen = (*(retptr+21)<<24)|(*(retptr+22)<<16)|(*(retptr+23)<<8)|(*(retptr+24)<<0);
					appReceviedCRC = (*(retptr+19)<<8)|(*(retptr+20)<<0);
			        Hal_FlsGetAppVectorTableStartAddr(&FlashAddStart);
			        Hal_OTAFlashAppInfoInit();
	                Hal_FlsErase(0,FlashAddStart + fileLen + FLS_INTERNAL_WRITE_SIZE, 100);
	                Hal_SetAppInfo(fileLen, appReceviedCRC, CONTROLLER_SELF);
					while(readLenAsk!=0)
					{
						memset(UartData,0x00,512);
						memset(FlashData,0x00,512);
						memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
						sprintf(ATSendDataBuffer, "AT+CFTRANTX=\"c:/%s\",%d,%d\r\n", filenamePtr,currentAddr, readLenAsk);
						UART_Query_Data(UART_LPUART1, UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), UartData, &ReadLen, pdMS_TO_TICKS(5000));
						sprintf(findDataBuffer, "+CFTRANTX: DATA,%d", readLenAsk);

						if(currentAddr % 0x100 == 0)
						{
							Dio_FlipChannel(DioConf_DioChannel_PTE9_GPIO_OUT_MCU_LED5);
						}

						if (ReadLen == (readLenAsk+strlen(findDataBuffer)+26))
						{
							retptr = (uint8 *)strstr((char *)UartData, findDataBuffer);
							if (retptr)
							{
								uint16 uartcrc = 0x00;
								uint16 flashcrc = 0xff;
								fileDataPtr = retptr+ 2 + mstrlen(findDataBuffer);
								FotaRecvDataLen_8 = ((readLenAsk+7)/8)*8;
								Hal_FlsWrite(FlashAddStart + currentAddr, fileDataPtr, FotaRecvDataLen_8, 100);
								Hal_FlsRead(FlashAddStart + currentAddr, FlashData, FotaRecvDataLen_8, 100);
								uartcrc = CRC16_Modbus(fileDataPtr,FotaRecvDataLen_8);
								flashcrc = CRC16_Modbus(FlashData,FotaRecvDataLen_8);
								if(flashcrc==uartcrc)
								{
									currentAddr = currentAddr + readLenAsk;
									getDataLenErrCount = 0;
								}
								else
								{
									uint32 secflash = (FlashAddStart + currentAddr) & 0xFFFFF000;
									if(secflash>0)
									{
										currentAddr = secflash - FlashAddStart;
									}
									else
									{
										currentAddr = 0;
									}
									MemIf_JobResultType ret = Hal_FlsErase(secflash,4096, 100);
									getDataLenErrCount++;
								}
								readLenAsk = min(fileLen-currentAddr,readLenAsk);
							}
							else
							{
								getDataLenErrCount++;
							}
						}
						else
						{
							getDataLenErrCount++;
						}
						if(getDataLenErrCount>=100)
						{
							break;
						}
					}

					Dio_WriteChannel(DioConf_DioChannel_PTE9_GPIO_OUT_MCU_LED5,STD_ON); //switch off the led

	                if(getDataLenErrCount<50&&Hal_FlsCheckIsTransferSucceed()==TRUE)
	                {
	                	ftp_process++;
	                }
	                else
	                {
	                	ftp_process++;
	                }
				}
			}
			else
			{
				ftp_process++;
			}
			break;
		}
		case 7://delete the bin and zl files
		{
	        memset(ATSendDataBuffer,0x00,sizeof(ATSendDataBuffer));
			sprintf(ATSendDataBuffer, "AT+FSDEL=*.*\r\n");
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATSendDataBuffer, mstrlen(ATSendDataBuffer), UartRecvBuffer, &ReadLen, pdMS_TO_TICKS(5000));
			ftp_process++;
			Fota_update_flag = TRUE;
			break;
		}
		default:
			ftp_EndFlg = 1;
			break;
		}
	}
	if(ftp_process<6)
	{
		Fota_error_flag = 1;
	}
}
